<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\IdeaRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\Idea;
use App\Language;
use App\Module;
use Users_model;

class IdeaController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/ideas';
    /** View folder */
    private $viewDirectory= 'admin.ideas.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('ideas.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the ideas.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query =Idea::orderBy('name', 'ASC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }

        if ($request->lang) {
            $query->whereIn('language_id', currentLanguageid($request->lang) );
        }

      

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $ideas= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('ideas'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('ideas.store');
        $head = metaFields('ideas', 'add_new', getCurrentLocale()) ?? __('ideas.new');
        $language = Language::where('status',1)->get();

        return view( $this->viewDirectory.'form', compact('action', 'head','language') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param IdeaRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(IdeaRequest $request) :RedirectResponse
    {

        foreach ($request->idea as $key => $row) {
           $idea= Idea::create($row);
        }
        

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  Idea  $idea
     * @return View
     */
    public function edit(Idea $idea): View
    {
        $action= route('ideas.update', $idea->id);
        $head = metaFields('idea', 'edit', getCurrentLocale()) ?? __('idea.edit');
        $language = Language::where('status',1)->get();

        return view( $this->viewDirectory.'form', compact( 'idea','action', 'head' ,'language' ) );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  IdeaRequest  $request
     * @param  Idea  $idea
     * @return RedirectResponse|Redirector
     */
    public function update(IdeaRequest $request, Idea $idea) :RedirectResponse
    {
        
        $idea->update($request->all());
        

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $idea = Idea::withTrashed()->find($id);
        if ($idea) {
            if ($idea->deleted_at) {
                $idea->forceDelete();
            } else {
                $idea->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Idea::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Idea::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $idea = Idea::withTrashed()->find($id);

        if ($idea){
            $idea->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $idea = Idea::whereIn('id', $request->ids)->onlyTrashed();
        if ($idea){
            $idea->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
